<template>
  <main>
    <mt-page-title validation>
      <h1 class="has-text-weight-bold is-size-3">Déclarer mes disponibilités</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
        La date de fin est antérieure à la date de début
      </b-message>
      <section class="mt-fields-section columns">
        <b-field label="date de Début" class="column">
          <b-datepicker
            v-model="disponibilite.dateDebut"
            placeholder="Sélectionnez une date de debut"
            :first-day-of-week="1"
            :month-names="monthNames"
            :day-names="dayNames"
            :date-parser="dateParse"
            editable
            icon="calendar-today"
            class="mt-input"
            @input="saisieDebut"
          />
        </b-field>
        <b-field label="date de Fin" class="column">
          <b-datepicker
            v-model="disponibilite.dateFin"
            placeholder="Sélectionnez une date de fin"
            :first-day-of-week="1"
            :month-names="monthNames"
            :day-names="dayNames"
            :date-parser="dateParse"
            editable
            icon="calendar-today"
            class="mt-input"
            @input="saisieFin"
          />
        </b-field>
      </section>
      <b-field label="STATUT">
        <div>
          <b-checkbox
            v-for="typeDisponibilite in typesDisponibilites"
            :key="typeDisponibilite.id"
            v-model="disponibilite.typeDisponibilite.id"
            :true-value="typeDisponibilite.id"
            :false-value="null"
          >
            <mt-disponibilite-puce :type-disponibilite="typeDisponibilite"></mt-disponibilite-puce>
            <span>
              {{ typeDisponibilite.libelle }}
            </span>
          </b-checkbox>
        </div>
      </b-field>

      <b-field label="COMMENTAIRE (FACULTATIF)">
        <b-input
          v-model="disponibilite.commentaire"
          type="textarea"
          placeholder="Ajoutez un commentaire"
          class="mt-input"
          maxlength="500"
        />
      </b-field>

      <div class="field is-grouped is-grouped-centered mt-margin-top">
        <div class="control">
          <nuxt-link :to="{ name: 'index' }" class="button is-secondary mt-button is-size-8 has-text-weight-semibold">
            annuler
          </nuxt-link>
        </div>
        <div class="control">
          <b-button
            class="mt-button is-size-8 has-text-weight-semibold"
            type="is-primary"
            native-type="submit"
            :disabled="disponibilite.typeDisponibilite.id === null"
          >
            Enregistrer
          </b-button>
        </div>
      </div>
      <mt-modal-ok :ouvert.sync="modalOuverte" @action="retourAccueil">
        Vos disponibilités ont été mises à jour.
      </mt-modal-ok>
    </form>
  </main>
</template>

<script>
import { mapGetters } from 'vuex';
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtModalOk from '~/components/modal/mt-modal-ok';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';

export default {
  components: {
    MtDisponibilitePuce,
    MtPageTitle,
    MtModalOk,
  },
  mixins: [DayMonthMixin],
  layout: 'container-small',
  computed: {
    ...mapGetters({
      typesDisponibilites: 'context/typesDisponibilites',
    }),
    dateInError() {
      if (!this.disponibilite.dateDebut || !this.disponibilite.dateFin) {
        return false;
      }
      return (
        !DateTime.fromJSDate(this.disponibilite.dateFin).hasSame(
          DateTime.fromJSDate(this.disponibilite.dateDebut),
          'day',
        ) && this.disponibilite.dateFin < this.disponibilite.dateDebut
      );
    },
  },
  asyncData() {
    return {
      disponibilite: {
        dateDebut: new Date(),
        dateFin: new Date(),
        typeDisponibilite: {
          id: null,
        },
        commentaire: '',
      },
      modalOuverte: false,
    };
  },
  methods: {
    async submit() {
      try {
        this.disponibilite.dateDebut.setHours(12);
        this.disponibilite.dateFin.setHours(12);
        await this.$api.utilisateur().postDisponibilite({
          ...this.disponibilite,
          dateDebut: this.disponibilite.dateDebut.toISOString(),
          dateFin: this.disponibilite.dateFin.toISOString(),
        });
        this.modalOuverte = true;
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    saisieDebut() {
      if (this.disponibilite.dateDebut > this.disponibilite.dateFin) {
        this.disponibilite.dateFin = this.disponibilite.dateDebut;
      }
    },
    saisieFin() {
      if (this.disponibilite.dateFin < this.disponibilite.dateDebut) {
        this.disponibilite.dateDebut = this.disponibilite.dateFin;
      }
    },

    retourAccueil() {
      this.$router.push('/');
    },
  },
};
</script>

<style scoped lang="scss"></style>
